//-----------------------------------------------
//---------------Panorama horizontal-----------
//-----------------------------------------------

void PanoLoop() {
  unsigned long currentMillis = millis();

  AccelStepperU.moveTo(tempGerundetU);
  AccelStepperV.moveTo(tempGerundetV);
  AccelStepperW.moveTo(tempGerundetW);
  AccelStepperX.moveTo(tempGerundetX);
  AccelStepperY.moveTo(tempGerundetY);
  AccelStepperZ.moveTo(tempGerundetZ);

  AccelStepperU.setAcceleration(accelerationAmountU);
  AccelStepperU.run();

  AccelStepperV.setAcceleration(accelerationAmountV);
  AccelStepperV.run();

  AccelStepperW.setAcceleration(accelerationAmountW);
  AccelStepperW.run();

  AccelStepperX.setAcceleration(accelerationAmountX);
  AccelStepperX.run();

  AccelStepperY.setAcceleration(accelerationAmountY);
  AccelStepperY.run();

  AccelStepperZ.setAcceleration(accelerationAmountZ);
  AccelStepperZ.run();


  if (panoCurrentPic < panoTotalPicAmount && pausePano == false) {
    if (currentMillis  - previousMillis > SMSdauer )
    {
      SMSstep++;  // nächster Schritt

      switch (SMSstep)
      {
        case 1: //DSLR auslösen

          digitalWrite(dslrFocus, HIGH);
          digitalWrite(dslrTrigger, HIGH);
          SMSdauer = 200; // sec warten
          break;

        case 2: //Belichten und Warten
          digitalWrite(dslrTrigger, LOW);
          digitalWrite(dslrFocus, LOW);
          panoCurrentPic++;
          //  Serial.print("panoCurrentPic:");
          //  Serial.println(panoCurrentPic);
          myString = String(panoCurrentPic);
          StringSend = "#panoCurrentPic_" + myString + "$";
          //  Serial.print("TLmaxexpo:");
          // Serial.println(TLmaxexpo);

          SMSdauer = TLmaxexpo;
          break;

        case 3: // Move



          if (((int)currentRow % 2) == 1) {
            if (currentColumn == panoColumns) {
              currentColumn = panoColumns;
              currentRow = currentRow + 1;
              //   Serial.println("---1");
            }
            else {
              currentColumn = currentColumn + 1;

              // Serial.println(currentColumn);

            }
          }

          else {
            if (currentColumn == 1) {
              currentColumn = 1;
              currentRow = currentRow + 1;

              // Serial.println("---3");
            }
            else {
              currentColumn = currentColumn - 1;
              // Serial.println("---4");
            }
          }



          currentColumnFLOAT =  ((float)currentColumn - 1) * PanoHorizontalMoveSteps;
          tempGerundetX = long(currentColumnFLOAT);



          currentRowFLOAT =  ((float)currentRow - 1) * PanoVerticalMoveSteps;
          tempGerundetY = long(currentRowFLOAT);

          // Serial.println(String(currentColumn));
          // Serial.println(String(tempGerundetX));
          // Serial.println(String(currentRow));
          // Serial.println(String(tempGerundetY));
          // Serial.println("---");

          myString = String(currentColumn);
          StringSend = "#currentColumn_" + myString + "$";
          Serial5.print(StringSend);

          delay(50);
          myString = String(currentRow);
          StringSend = "#currentRow_" + myString + "$";
          Serial5.print(StringSend);

          SMSdauer = 500;
          break;

        case 4: // Delay
          // Serial.print("TLdelay:");
          // Serial.println(TLdelay);
          SMSdauer = TLdelay + 500;
          //SMSdauer = 300;
          break;

        default:
          // Serial.println(AccelStepperY.currentPosition());
          SMSstep = 0;
          SMSdauer = 1;     // Schrittfolge wieder von vorn
      }

      if (pausePano == false) {
        // Serial.println("444");
        previousMillis = currentMillis; // "Delay" neu starten
      }





    }  //  if (currentMillis  - previousMillis > Dauer )
  }

  else {
    digitalWrite(dslrTrigger, LOW);
    digitalWrite(dslrFocus, LOW);
    startPano = false;
  }

}

//-----------------------------------------------
//---------------Panorama vertical-----------
//-----------------------------------------------

void PanoLoopVertical() {
  unsigned long currentMillis = millis();

  AccelStepperU.moveTo(tempGerundetU);
  AccelStepperV.moveTo(tempGerundetV);
  AccelStepperW.moveTo(tempGerundetW);
  AccelStepperX.moveTo(tempGerundetX);
  AccelStepperY.moveTo(tempGerundetY);
  AccelStepperZ.moveTo(tempGerundetZ);

  AccelStepperU.setAcceleration(accelerationAmountU);
  AccelStepperU.run();

  AccelStepperV.setAcceleration(accelerationAmountV);
  AccelStepperV.run();

  AccelStepperW.setAcceleration(accelerationAmountW);
  AccelStepperW.run();

  AccelStepperX.setAcceleration(accelerationAmountX);
  AccelStepperX.run();

  AccelStepperY.setAcceleration(accelerationAmountY);
  AccelStepperY.run();

  AccelStepperZ.setAcceleration(accelerationAmountZ);
  AccelStepperZ.run();

  if (panoCurrentPic < panoTotalPicAmount && pausePano == false) {
    //Serial.println("111");
    if (currentMillis  - previousMillis > SMSdauer )
    {
      SMSstep++;  // nächster Schritt
      //Serial.println("222");
      switch (SMSstep)
      {
        case 1: //DSLR auslösen

          digitalWrite(dslrFocus, HIGH);
          digitalWrite(dslrTrigger, HIGH);
          SMSdauer = 200; // sec warten
          break;

        case 2: //Belichten und Warten
          digitalWrite(dslrTrigger, LOW);
          digitalWrite(dslrFocus, LOW);
          panoCurrentPic++;
          //  Serial.print("panoCurrentPic:");
          // Serial.println(panoCurrentPic);
          myString = String(panoCurrentPic);
          StringSend = "#panoCurrentPic_" + myString + "$";
          Serial5.print(StringSend);
          SMSdauer = TLmaxexpo;
          // Serial.print("TLmaxexpo:");
          //Serial.print(TLmaxexpo);
          break;

        case 3: // Move



          if (((int)currentColumn % 2) == 1) {
            if (currentRow == panoRows) {
              currentRow = panoRows;
              currentColumn = currentColumn + 1;
              //   Serial.println("---1");
            }
            else {
              currentRow = currentRow + 1;

              // Serial.println(currentColumn);

            }
          }

          else {
            if (currentRow == 1) {
              currentRow = 1;
              currentColumn = currentColumn + 1;

              // Serial.println("---3");
            }
            else {
              currentRow = currentRow - 1;
              // Serial.println("---4");
            }
          }


          currentColumnFLOAT =  ((float)currentColumn - 1) * PanoHorizontalMoveSteps;
          tempGerundetX = long(currentColumnFLOAT);

          currentRowFLOAT =  ((float)currentRow - 1) * PanoVerticalMoveSteps;
          tempGerundetY = long(currentRowFLOAT);

          //Serial.println(String(currentColumn));
          // Serial.println(String(tempGerundetX));
          //Serial.println(String(currentRow));
          // Serial.println(String(tempGerundetY));
          // Serial.println("---");

          myString = String(currentColumn);
          StringSend = "#currentColumn_" + myString + "$";
          Serial5.print(StringSend);

          delay(50);
          myString = String(currentRow);
          StringSend = "#currentRow_" + myString + "$";
          Serial5.print(StringSend);

          SMSdauer = 500;
          break;

        case 4: // Delay
          //   Serial.print("TLdelay:");
          //  Serial.println(TLdelay);
          SMSdauer = TLdelay + 500;
          //SMSdauer=300;
          break;

        default:
          // Serial.println(AccelStepperY.currentPosition());
          SMSstep = 0;
          SMSdauer = 1;     // Schrittfolge wieder von vorn
      }

      if (pausePano == false) {
        //  Serial.println("444");
        previousMillis = currentMillis; // "Delay" neu starten
      }


    }  //  if (currentMillis  - previousMillis > Dauer )
  }
  else {
    digitalWrite(dslrTrigger, LOW);
    digitalWrite(dslrFocus, LOW);
    startPanoVertical = false;
    //  Serial.println("666");
  }

}










